/* N-body calculation using Greenspan 1st-order discrete mechanics.    */
/* Incorporates xyz-parallelism, uses domain pointers, combines        */
/* particle and pair domains, diagonal processors store particles      */
/* Spreading and accumulation coded in PARIS, more globals,            */
/* Booleans stored in char fields.                                     */

#include "nb3dpr.hs"

void main()
 { int ns, np, nl, nv, k, vl;  float dt, eps;
   char fnm[50];
   /* Performs np integrations, each ns steps of dt */
     printf("Data file> ");  scanf("%s", fnm);
     datap = fopen(fnm, "r");
     fscanf(datap, "%d", &NB);
     [domain pair].{ setup();  init(); };
     fscanf(datap, "%d%d%e%e", &ns, &np, &dt, &eps);
     fclose(datap);
     printf("\n   G = %13.6e  delta-t = %12.5e  epsilon = %12.5e\n",
                   G, dt, eps);
     printf("\n simulated time = 0");
     [domain pair].{ print_state(); };
     for ( k = 0; k < np; k++ )
      { CM_start_timer(1);
        cfail = 0;
        vl = green1(ns, dt, eps);
        CM_stop_timer(1);  CM_reset_timer();
        printf(
	 "\n simulated time = %9.3f  %d evaluations  %d iterations limited\n",
	  (k + 1)*ns*dt, vl, cfail);
        [domain pair].{ print_state(); };
      };
 }

